# coding=utf-8
from django.utils import simplejson
from georemindme.models import  Point

def getAlertsJSON(alerts):
    
    return simplejson.dumps([{	'id': a.id,
                                'name': a.name,
                                'description':a.description,
                                'x':a.poi.point.lat,
                                'y':a.poi.point.lon,
                                'address':unicode(a.poi.address),
                                'starts':str(a.starts),
                                'ends':str(a.ends),
                                'donedate':str(a.done_when.strftime("%d%b")) if a.done_when else '',
                                'done':a.is_done(),
                                'distance':a.get_distance() }
                          for a in alerts if isinstance(a.poi,Point)])
    
def init_user_session(request, user, remember=True):
    '''
    when a user logs in, we need to initialize a new session,
    save session in user, and save the user in the session
    '''
    from appengine_utilities.sessions import Session
    lang = request.session['LANGUAGE_CODE']
    request.session = Session(set_cookie_expires=remember)#register the user with session
    request.session['LANGUAGE_CODE'] = lang#saved language
    user._session = request.session.get_ds_entity()
    from datetime import datetime
    user.last_login = datetime.now()
    if not user.profile: 
        from georemindme.models import UserProfile
        p = UserProfile(user=user)
        p.put()
    user.put()
    request.session['user'] = user
