from urllib import urlencode
import urllib2
import OAuthRequest

class OAuthClient(object):
    request_token_url = ''
    access_token_url = ''
    authorization_url = ''
    callback_url = ''
    resource_url = ''
    
    def fetch_request_token(self, oauth_request):
        '''
        send the request to the provider and returns the (OAuthToken) Unathorized token
        '''
        udata = urlencode(oauth_request.parameters)
        r= urllib2.Request('%s?%s' % (self.request_token_url, udata))
        try:
            response = urllib2.urlopen(r)
            return OAuthRequest.OAuthToken.from_response(response.read())
        except:
            return None
        
    def fetch_access_token(self, oauth_request):
        '''
        Returns the (OAuthToken) Authorized Access token
        '''
        udata = urlencode(oauth_request.parameters)
        r= urllib2.Request('%s?%s' % (self.access_token_url, udata))
        try:
            response = urllib2.urlopen(r)
            return OAuthRequest.OAuthToken.from_response(response.read())
        except:
            return None
    
    def get_token_authorize_url(self, oauth_request):
        '''
        return the url where you need to redirect the user so he can authorize your access 
        '''
        udata = urlencode(oauth_request.parameters)
        return '%s?%s' % (self.authorization_url, udata)
        
    def access_resource(self, oauth_request):
        '''
        using a authorized token, access to the providers resource
        '''
        udata = urlencode(oauth_request.parameters)
        r = urllib2.Request(self.resource_url, data = udata)
        r.add_header('Content-Type', 'application/x-www-form-urlencoded')
        response = urllib2.urlopen(r)
        return response.read()
    
class TwitterClient(OAuthClient):
    request_token_url = 'https://api.twitter.com/oauth/request_token'
    access_token_url = 'https://api.twitter.com/oauth/access_token'
    authorization_url = 'https://api.twitter.com/oauth/authorize'
    callback_url = 'http://georemindme.appspot.com/oauth/authorized/twitter'
    resource_url = ''

class OAuthConsumer(object):
    '''Consumer of OAuth authentication.
    OAuthConsumer is a data type that represents the identity of the Consumer
    via its shared secret with the Service Provider.
    '''
    key = None
    secret = None

    def __init__(self, key, secret):
        self.key = key
        self.secret = secret
        
class BadProvider(Exception):
    pass
    
class OAuthConsumerClientFactory(object):
    @classmethod
    def getInstances(self, provider=None):
        if provider == 'twitter':
            consumer = OAuthConsumer('RlxmqqhM2EkWXiKlji1yA','I3eJawYaPalgrXjWFc8u8meKpfeNnJrI5XFPdT3Eg')
            client =  TwitterClient()
            
        else:
            raise BadProvider()
            
        return consumer, client