# coding=utf-8
"""
This file is part of GeoRemindMe.

GeoRemindMe is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

GeoRemindMe is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GeoRemindMe.  If not, see <http://www.gnu.org/licenses/>.


"""
import time

from OAuthConsumerClientFactory import OAuthConsumerClientFactory
import OAuthRequest
    
    
def run():
    consumer, client = OAuthConsumerClientFactory.getInstances(provider='twitter')
    
    print "Request token"
    request = OAuthRequest.OAuthRequest.get_request_token(oauth_consumer=consumer, callback=client.callback_url, http_url=client.request_token_url)
    print request.parameters
    pause()
    token = client.fetch_request_token(request)
    print "TOKEN:"
    print token.key + '\n' + token.secret
    pause()
    print "AUTHORIZATION URL:"
    request = OAuthRequest.OAuthRequest.authorize_request_token(token=token, callback=client.callback_url, http_url=client.authorization_url)
    print client.get_token_authorize_url(request)
    pause()
    print "AUTHORIZED TOKEN:"
    request = OAuthRequest.OAuthRequest.get_from_provider(oauth_consumer=consumer, token=token,
                                                          http_url=client.authorization_url,
                                                          )
    token = client.fetch_access_token(request)
def pause():
    print '==PAUSE=='
    time.sleep(1)
    
if __name__ == '__main__':
    run()
    print 'Done.'